[LeetCode#133]Clone Graph
6326 단어 LeetCode
Clone an undirected graph. Each node in the graph contains a
label
and a list of its neighbors
. OJ's undirected graph serialization:
Nodes are labeled uniquely. We use
#
as a separator for each node, and ,
as a separator for node label and each neighbor of the node. As an example, consider the serialized graph
{0,1,2#1,2#2,2}
. The graph has a total of three nodes, and therefore contains three parts as separated by
#
. 0
. Connect node 0
to both nodes 1
and 2
. 1
. Connect node 1
to node 2
. 2
. Connect node 2
to node 2
(itself), thus forming a self-cycle. Visually, the graph looks like the following:
1
/ \
/ \
0 --- 2
/ \
\_/
My analysis:
The implementation pattern used in this problem is very classic in cloning a graph.
The key idea: use a hash map to store and retrieve the copy of a node. <original, copy>
The basic idea is to use the invariant:
1. we dequeue a node from the queue, then we scan the node's neighbors. we check if the neighbor node has already been traversaled by using the "containKeys()" method.
1.1 iff the node is in the hashmap, we would not make a copy for it.
1.2 iff the node is not in the hashmap, we make a copy for this neighbor node. Put the <neighbor_node, copy> into the hashmap and enqueue the neighbor node.
if (!map.containsKey(cur.neighbors.get(i))) {//this node has not been traversaled
copy = new UndirectedGraphNode(cur.neighbors.get(i).label);
map.put(cur.neighbors.get(i), copy);
queue.offer(cur.neighbors.get(i));
}
Note1: we only enqueue nodes from neighbors list, which means all neighbors list of remaining nodes in the queue(until the dequeue) has not been copyed yet. Thus, for each current node's neghbor list, we need to fully copy it.
for (int i = 0; i < cur.neighbors.size(); i++) {
if (!map.containsKey(cur.neighbors.get(i))) {
...
}
map.get(cur).neighbors.add(map.get(cur.neighbors.get(i)));
}
Note2: to use the invariant, we need to make necessary preparation for it (dummy layer). we should suppose there is dummy layer copy the starting node, and then put it into hashmap and enqueue the starting node.
My solution:
public class Solution {
public UndirectedGraphNode cloneGraph(UndirectedGraphNode node) {
if (node == null)
return null;
HashMap<UndirectedGraphNode, UndirectedGraphNode> map = new HashMap<UndirectedGraphNode, UndirectedGraphNode> ();
Queue<UndirectedGraphNode> queue = new LinkedList<UndirectedGraphNode> ();
UndirectedGraphNode cur;
UndirectedGraphNode copy = new UndirectedGraphNode(node.label);
queue.offer(node);
map.put(node, copy);
while(!queue.isEmpty()) {
cur = queue.poll();
for (int i = 0; i < cur.neighbors.size(); i++) {
if (!map.containsKey(cur.neighbors.get(i))) {//this node has not been traversaled
copy = new UndirectedGraphNode(cur.neighbors.get(i).label);
map.put(cur.neighbors.get(i), copy);
queue.offer(cur.neighbors.get(i));
}
map.get(cur).neighbors.add(map.get(cur.neighbors.get(i)));
}
}
return map.get(node);
}
}
이 내용에 흥미가 있습니까?
현재 기사가 여러분의 문제를 해결하지 못하는 경우 AI 엔진은 머신러닝 분석(스마트 모델이 방금 만들어져 부정확한 경우가 있을 수 있음)을 통해 가장 유사한 기사를 추천합니다:
python 문자열 입력으로 모든 유효한 IP 주소 생성(LeetCode 93번 문제)이 문제의 공식 난이도는 Medium으로 좋아요 1296, 반대 505, 통과율 35.4%를 눌렀다.각 항목의 지표로 말하자면 보기에는 약간 규범에 맞는 것 같지만, 실제로도 확실히 그렇다.이 문제의 해법과 의도는 ...
텍스트를 자유롭게 공유하거나 복사할 수 있습니다.하지만 이 문서의 URL은 참조 URL로 남겨 두십시오.
CC BY-SA 2.5, CC BY-SA 3.0 및 CC BY-SA 4.0에 따라 라이센스가 부여됩니다.